/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CICLOCIA                                                 */
/* Tabela : CICLOCIA                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CICLOCIA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CICLOCIA
GO

CREATE TRIGGER DTULTATU_CICLOCIA
ON CICLOCIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CICLOCIA', null, 'CDFILIAL='+ CDFILIAL+ ';'+
                                       'CDCIA='   + CDCIA   + ';'+
                                       'CDCICLO=' + CDCICLO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CICLOCIA
      SET DTULTATUCCIA = GETDATE()
      FROM INSERTED;
   END;
END;
GO

