function Est12000_EmissaoDosLancamentosDeEntrada_Controller(EstUtil, ScreenService, General, templateManager,ZhFilterPreferences, Est12000_EmissaoDosLancamentosDeEntrada_Service) {

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        let rowsToSet  = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = [success.dataset.filial[0].CDFILIAL];
            rowsToSet.NMFILIAL = [success.dataset.filial[0].NMFILIAL];
            ZhFilterPreferences.openFilterWidget(widget,rowsToSet).then(function(success) {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NMFILIAL").reload();
                this.verAlmoxEstoque(templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions'));
            }.bind(this));
        }.bind(this));
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.getFilialLogada = function() {
    var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
	    ];
    return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    // Habilita/Desabilita Almoxarifado e Localização
    this.verAlmoxEstoque = function(args){
            
        let widget = templateManager.container.getActiveWidget();
        
        if(widget.name != 'zhFilterPreferencesSelectConditions'){
            widget = args;
        }
        Est12000_EmissaoDosLancamentosDeEntrada_Service.getParamFilialData(widget).then(() =>{
            
            let almoxField = widget.getField('DSALMOXARIFE');
            let LocalField = widget.getField('DSLOCALESTOQ');
            let cdAlmoxField = widget.getField('CDALMOXARIFE');
            
            if(widget.currentRow.IDUTILALMOX === 'S'){
                //almoxField.validations = {"required": {"message": "Campo Obrigatório"}};
                almoxField.readOnly = false;
            }else{
                //delete almoxField.validations;
                almoxField.readOnly = true;
                almoxField.clearValue();
                cdAlmoxField.clearValue();
            }
            if(widget.currentRow.IDUTILLCESTQ === 'S'){
                //LocalField.validations = {"required": {"message": "Campo Obrigatório"}};
                LocalField.readOnly = false;
            }else{
                //delete LocalField.validations;
                LocalField.readOnly = true;
                LocalField.clearValue();
                cdAlmoxField.clearValue();
            }
        });
    };
    
    this.checkProductRange = function(field) {
        var currentRow = field.widget.currentRow;
      
        if(currentRow.CDPRODINI && currentRow.CDPRODFIN) {
            var compproduto = (currentRow.CDPRODFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if(!General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;

                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        } 
    };
	
	this.cleanFieldsOnChange = function(field){
        let widget = field.widget;
        let fieldProdIni = widget.getField('NMPRODINI');
        let fieldProdFim = widget.getField('NMPRODFIN');
        let fieldGrupProd = widget.getField('NMGRUPPROD');
        
        switch(field.name){
            case 'NMPRODFIN':
            case 'NMPRODINI':
                fieldProdIni.validations = {"required": true};
                fieldProdFim.validations = {"required": true};
                delete fieldGrupProd.validations;
                widget.currentRow.NMGRUPPROD = '';
                break;
            case 'NMGRUPPROD':
                widget.currentRow.NMPRODINI = '';
                widget.currentRow.NMPRODFIN = '';
                delete fieldProdIni.validations;
                delete fieldProdFim.validations;
                fieldGrupProd.validations = {"required": true};
        }
        
    };
}


Configuration(function(ContextRegister){
    ContextRegister.register('Est12000_EmissaoDosLancamentosDeEntrada_Controller', Est12000_EmissaoDosLancamentosDeEntrada_Controller);
});